/*  www.sgm.siedlce.pl, program do wykorzystania tylko na wlasny uzytek

poprawiony test detekcji jednego kanalu odbiornika RC
(na kanale przepustnicy, FailSafe = 1100uS)
pomiar sygnału przepustnicy na wejsciu (D2)
w oparciu o przerwanie; obsługa przerwania --> procedury:
void pulse_rising()
void pulse_falling()

dozwolony zakres dlugosci impulsu: 900-2100uS

serwo testowe podlaczone (D8)

opcjonalnie wydruk zmierzonych wartosci na port szeregowy

pomiar czasu przy uzyciu biblioteki:
===================================================================================================
<eRCaGuy_Timer2_Counter.h> by Gabriel Staples
Visit my blog at http://electricrcaircraftguy.blogspot.com/
-My contact info is available by clicking the "Contact Me" tab at the top of my blog.
-Please support my work & contributions by buying something here: https://sites.google.com/site/ercaguystore1/
My original post containing this code can be found here: http://electricrcaircraftguy.blogspot.com/2014/02/Timer2Counter-more-precise-Arduino-micros-function.html
Written: 17 May 2014
Updated: 30 May 2014
===================================================================================================
  LICENSE & DISCLAIMER
  Copyright (C) 2015 Gabriel Staples.  All right reserved.
  
  ------------------------------------------------------------------------------------------------
  License: GNU Lesser General Public License Version 3 (LGPLv3) or later - https://www.gnu.org/licenses/lgpl.html
  ------------------------------------------------------------------------------------------------

  This file is part of eRCaGuy_Timer2_Counter.
  
  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program.  If not, see http://www.gnu.org/licenses/
===================================================================================================
*/

//dolaczenie biblioteki
#include <eRCaGuy_Timer2_Counter.h>
// uzycie funkcji timer2.get_count() - podaje wynik w jednostkach 0.5us


//deklaracje zmiennych

volatile unsigned long pulse_start = 0; //zmienna dla get_count()  
volatile unsigned long pulse_uS = 0;    //zmienna na dlugosc impulsu kanalowego                              
int pulse_uSi; //zmienna pomocnicza                                              

#include <Servo.h>               // dolaczenie biblioteki 'servo'
Servo myservo;                   // utworzenie obiektu do sterowania serwem 

const int servoFS = 1500;        //wartosc domyslna impulsu RC
int servoP;                      //zmienna na sygnal wyjsciowy servo

int tGap = 300;                  //opcjonalnie - co ile wydruk danych (msec)
unsigned long t_start;           //zmienne do odliczania czasu przy wydruku
unsigned long t_count; 

//inicjalizacja programu
void setup() { 
  //obowiazkowa inicjalizacja Timer2 wymagana przez
  //biblioteke <eRCaGuy_Timer2_Counter.h>
  timer2.setup(); 
  // inicjalizacja serwa do D8
  servoP = servoFS;
  myservo.attach(8);      
  myservo.writeMicroseconds(servoP);
  
  //inicjalizacja portu szeregowego (opcjonalny wydruk danych)
  //Serial.begin(115200); 
  
  //inicjalizacja przerwania 0 (D2, Arduino UNO)
  attachInterrupt(0, pulse_rising, RISING);
  t_start = millis();  
}

//glowna petla programu
void loop() {
  // tutaj program uzytkowy, bazujacy na zmierzonym
  // czasie trwania impulsu kanlaowego PPM
  
  //opcjonalnie obsulga drukowania co 'tGap' pomiaru na port szeregowy  
  /*
  t_count = millis(); 
  //jesli uplynelo tGap to drukuj
  if ((t_count - t_start) >= tGap) 
  {
    t_start = t_count;
    Serial.println(servoP);
  }
  */

} // koniec glownej petli



// obsluga przerwania (rising), poczatek impulsu
void pulse_rising() {
  pulse_start = timer2.get_count();
  attachInterrupt(0, pulse_falling, FALLING);  
}



// obsluga przerwania (falling), koniec impulsu 
void pulse_falling() {
  //dlugosc impulsu w microsec()
  pulse_uS = (timer2.get_count()-pulse_start)/2;
  pulse_uSi = pulse_uS;
  //sprawdzenie czy dlugosc impulsu z dozwolonego zakresu
  if ((pulse_uSi > 900) && (pulse_uSi < 2100)) {
     servoP = pulse_uSi;
     myservo.writeMicroseconds(servoP);
  }   //if ((pulse1_getm > 900
  
  attachInterrupt(0, pulse_rising, RISING);
  timer2.reset(); 
           
}





